
#include <stdio.h>
#include "IMAG.H"
//#include<io.h>
//#include<unistd.h>
#include <string.h>
#include "sys/alt_dma.h"
#include "system.h"
#include <alt_types.h>
#include "altera_avalon_dma.h"
#include "sys/alt_irq.h"
#include "altera_avalon_dma_regs.h"


#define VGA_WIDTH 640
#define VGA_HEIGHT 480
#define ASC_SIZE 128
#define H_FKN 10
#define V_FKN 18
#define FK_SIZE 16
#define myled *(unsigned int *)PIO_LED_BASE
#define key *(unsigned int *)PIO_0_BASE
static unsigned int V_nWidth = H_FKN * FK_SIZE;
static unsigned int V_nHeight = V_FKN * FK_SIZE;

static unsigned char IMG_DATA[36][48];
static unsigned char IMG_DATA2[41][265];
static unsigned char IMG_DATA3[38][222];
static unsigned char ASC_DATA[ASC_SIZE][16];
static volatile unsigned char *P_ASC_FLASH=
                   (unsigned char *)CFI_FLASH_0_BASE +0x100000;
static volatile unsigned char *P_HZK_FLASH=
                   (unsigned char *)CFI_FLASH_0_BASE +0x150000;                   
static volatile unsigned char *P_VGA=
                  (unsigned char *)(VGA_CONTROLLER_STREAM_0_BASE);                  
static volatile unsigned char *P_VGA_RAM=
                   (unsigned char *)(SDRAM_0_BASE +0x500000);
const unsigned long TLENGTH=
                    VGA_WIDTH * VGA_HEIGHT/2;
void draw_str(unsigned int x,unsigned int y, 
              unsigned char *str,int len,unsigned char color);                   
void init_dma(void); 
void draw_pixel(unsigned int x,unsigned int y,unsigned char color);
void isr_dma(int context);  
void init_fk(void);   
void clear_bk(unsigned int left,unsigned int top,unsigned int width,unsigned int height,
            unsigned char color);    
void load_asc(void); 
void draw_hz(unsigned int x,unsigned int y,unsigned char hz[2],char color);              
void draw_asc(unsigned int x,unsigned int y, 
              unsigned char asc,unsigned char color);
void draw_str(unsigned int x,unsigned int y, 
              unsigned char *str,int len,unsigned char color); 
void load_img(void); 
void draw_img(unsigned int x,unsigned int y,unsigned char color);                    
void init_myHZ(void);
void load_img2(void); 
void draw_img2(unsigned int x,unsigned int y,unsigned char color);                    
void load_img3(void); 
void draw_img3(unsigned int x,unsigned int y,unsigned char color);
void mychar(void);              
void moveHZ(void);
void clear(void);
void delay(unsigned char M);
unsigned char chcolor; 
             

int main(void)
{
//  init_dma();
clear();
int i;
unsigned char led=0x01;
 init_myHZ();
 draw_img(10,10,0x02);
 init_dma();
 while(1)
{
  for(i=0;i<100000;i++);
  led=~led;
  myled=led;
  if(key!=0x07)
   {
    switch(key)
    {
     case 0x06:
      clear();
      //clear_bk(0,0,VGA_WIDTH,VGA_HEIGHT,0);
      draw_img3(10,1,0x02); break;
     case 0x05: 
      {
       if(++chcolor>0x07)
        chcolor=1;
        mychar();
       };break;
     case 0x03:
      clear();
      //clear_bk(0,0,VGA_WIDTH,VGA_HEIGHT,0);
      draw_img2(0,1,0x02); break;
     case 0x04:
      moveHZ(); break;
     default: break;
    }
   }
  }
  return (0);
};

void draw_pixel(unsigned int x,unsigned int y,unsigned char color)
{
  unsigned long addr;
 if (x>VGA_WIDTH)
     x%=VGA_WIDTH;
 if (y > VGA_HEIGHT)
     y %= VGA_HEIGHT;
    
  addr=VGA_WIDTH * y + x;
  P_VGA_RAM[addr] = color;
};

void load_asc(void)
{
  volatile unsigned char *xasc;
  int i,j;
  for(i=0;i<ASC_SIZE;++i)
  {
    xasc=P_ASC_FLASH+(i*16);
    for(j=0;j<16;j++)
    {
     ASC_DATA[i][j]=xasc[j];
    }
  }
};

void draw_asc(unsigned int x,unsigned int y,unsigned char asc,unsigned char color)
 {
  unsigned char ch;
  unsigned int px,py;
  for(py=0;py<16;++py)
  {
    ch=ASC_DATA[asc][py];
    for(px=0;px<8;++px)
    {
      if(ch&(0x01<<(7-px)))
        draw_pixel(x+px,y+py,color);
        else
         draw_pixel(x+px,y+py,0);
    }
  }
};
void draw_hz(unsigned int x,unsigned int y,unsigned char hz[2],char color)
{
  volatile unsigned char *xhz;
  unsigned char ch;
  unsigned int dx,dy,i;
  xhz = P_HZK_FLASH + (((hz[0] - 0xa1) * 94 + (hz[1] - 0xa1)) *32);
  for(dy=0;dy<16;++dy)
  {   
     for( dx=0;dx<2;++dx)
       {
          ch = xhz[(dy*2) + dx];
          for(i=0;i<8;++i)
           {
            if(ch&(0x01<<(7-i)))
               draw_pixel(x+dx*8+i,y+dy,color);
               else 
                 draw_pixel(x+dx*8+i,y+dy,0);
           }
       }
     }
  };
  
void draw_str(unsigned int x,unsigned int y,
               unsigned char *str,int len,unsigned char color)
   {
    int i;
    for(i = 0;i<len;++i)
     {
      if(str[i]<0xa1)
        draw_asc(x+(i*8),y,str[i],color);
      else
       {
         if(i+1<len && str[i+1] >= 0xa1)
          {
          draw_hz(x+(i*8),y,str+i,color);
          ++i;
          }
       }
     }
   };
   
  void init_myHZ(void)
 { 
 // unsigned int i,j;
  unsigned char str_temp[30] = "SOPCVGA";
 load_asc();
 draw_str((VGA_WIDTH + V_nWidth) / 2,
          (VGA_HEIGHT - V_nHeight) / 2,
          str_temp,strlen(str_temp),0x07);
 sprintf(str_temp,"ѧ:010221215") ; 
  draw_str((VGA_WIDTH + V_nWidth) / 2+32,
          (VGA_HEIGHT - V_nHeight) / 2+32,
          str_temp,strlen(str_temp),0x06);
 sprintf(str_temp,":ӱ") ; 
  draw_str((VGA_WIDTH + V_nWidth) / 2+32,
          (VGA_HEIGHT - V_nHeight) / 2+64,
          str_temp,strlen(str_temp),0x03);
 } 
  void mychar(void)
 { 
 // unsigned int i,j;
  unsigned char str_temp[30];
  sprintf(str_temp,"Welcome GLIET") ;
 draw_str((VGA_WIDTH + V_nWidth) / 2+30 ,
          (VGA_HEIGHT - V_nHeight) / 2 - 30,
          str_temp,strlen(str_temp),chcolor);
 
 } 
  
 void moveHZ(void)
 { 
  unsigned char i;
  unsigned char str_temp[10] = "";
  for(i=0;;i++) 
  {
    if(key==0x06)
    break;
    if(key==0x05) 
      {
       if(++chcolor>0x07)
        chcolor=1;
      }
   draw_str(10+i,180,str_temp,strlen(str_temp),chcolor);
   delay(10);
   draw_str(10+i,180,str_temp,strlen(str_temp),0x00);
  }
 }
  
 void delay(unsigned char M)
{
  int i;
  while(M--)
  {
    for(i=0;i<100;i++);
  }
}
  
void clear_bk(unsigned int left,unsigned int top,unsigned int width,unsigned int height,
            unsigned char color)
 {
 unsigned long addr;
 unsigned int i,j;
  for(i=0;i<height;i++)
  {
  for(j=0;j<width;j++)
   {
     addr=(VGA_WIDTH * (top + i)) + left +j;
      if (addr > TLENGTH)
         addr %=TLENGTH;
          P_VGA_RAM[addr]=color;
   }
  }
 }

void load_img(void)
{
  unsigned char *p=&IMAG[0];
  int i,j;
  for(i=0;i<48;++i)
  {
    for(j=0;j<36;++j)
    {
     IMG_DATA[j][i]=*(p++);
    }
  }
};

void draw_img(unsigned int x,unsigned int y,unsigned char color)
 {
  unsigned char ch,img;
  unsigned int px,py;
  load_img();
  for(img=0;img<36;++img)
     {
      for(py=0;py<48;++py)
      {
       ch=IMG_DATA[img][py];
       for(px=0;px<8;++px)
        {
        if(ch&(0x01<<(7-px)))
          draw_pixel(x+px+img*8,y+py,color);
          else
          draw_pixel(x+px+img*8,y+py,0);
        }
    }
  }
};

void load_img2(void)
{
  unsigned char *p=&IMAG2[0];
  int i,j;
  for(i=0;i<265;++i)
  {
    for(j=0;j<41;++j)
    {
     IMG_DATA2[j][i]=*(p++);
    }
  }
};

void draw_img2(unsigned int x,unsigned int y,unsigned char color)
 {
  unsigned char ch,img;
  unsigned int px,py;
  load_img2();
  for(img=0;img<41;++img)
     {
      for(py=0;py<265;++py)
      {
       ch=IMG_DATA2[img][py];
       for(px=0;px<8;++px)
        {
        if(ch&(0x01<<(7-px)))
          draw_pixel(x+px+img*8,y+py,color);
          else
          draw_pixel(x+px+img*8,y+py,0);
        }
    }
  }
};

void load_img3(void)
{
  unsigned char *p=&IMAG3[0];
  int i,j;
  for(i=0;i<222;++i)
  {
    for(j=0;j<38;++j)
    {
     IMG_DATA3[j][i]=*(p++);
    }
  }
};

void draw_img3(unsigned int x,unsigned int y,unsigned char color)
 {
  unsigned char ch,img;
  unsigned int px,py;
  load_img3();
  for(img=0;img<38;++img)
     {
      for(py=0;py<222;++py)
      {
       ch=IMG_DATA3[img][py];
       for(px=0;px<8;++px)
        {
        if(ch&(0x01<<(7-px)))
          draw_pixel(x+px+img*8,y+py,color);
          else
          draw_pixel(x+px+img*8,y+py,0);
        }
    }
  }
};

void clear(void)
{
unsigned int i;
for(i=0;i<TLENGTH;i++)
   { 
      P_VGA_RAM[i]=0x00;
   }
};

void DMA_interrupts(void* context, alt_u32 id);

void init_dma(void)
{  
alt_irq_register(DMA_0_IRQ,0,DMA_interrupts); 
IOWR_ALTERA_AVALON_DMA_CONTROL (DMA_0_BASE, 0);
IOWR_ALTERA_AVALON_DMA_STATUS (DMA_0_BASE, 0);

IOWR_ALTERA_AVALON_DMA_LENGTH (DMA_0_BASE, TLENGTH);

IOWR_ALTERA_AVALON_DMA_RADDRESS (DMA_0_BASE,(int)P_VGA_RAM);
IOWR_ALTERA_AVALON_DMA_WADDRESS (DMA_0_BASE,(int)P_VGA);

IOWR_ALTERA_AVALON_DMA_CONTROL (DMA_0_BASE, 
                          ALTERA_AVALON_DMA_CONTROL_HW_MSK      | 
                          ALTERA_AVALON_DMA_CONTROL_GO_MSK        |
                         ALTERA_AVALON_DMA_CONTROL_I_EN_MSK      |
                         ALTERA_AVALON_DMA_CONTROL_WCON_MSK      |
              //            ALTERA_AVALON_DMA_CONTROL_WEEN_MSK      |
                         ALTERA_AVALON_DMA_CONTROL_LEEN_MSK
              );

}

void DMA_interrupts(void* context, alt_u32 id)
{    
 // int i;
 // for(i=0;i<300;i++);
  int si=IORD_ALTERA_AVALON_DMA_STATUS (DMA_0_BASE);
if(si&0x1)
  {
   IOWR_ALTERA_AVALON_DMA_CONTROL (DMA_0_BASE, 0);
IOWR_ALTERA_AVALON_DMA_STATUS (DMA_0_BASE, 0);
 IOWR_ALTERA_AVALON_DMA_CONTROL (DMA_0_BASE, 0);
IOWR_ALTERA_AVALON_DMA_LENGTH (DMA_0_BASE, TLENGTH);

IOWR_ALTERA_AVALON_DMA_RADDRESS (DMA_0_BASE,(int)P_VGA_RAM);
IOWR_ALTERA_AVALON_DMA_WADDRESS (DMA_0_BASE,(int)P_VGA);

IOWR_ALTERA_AVALON_DMA_CONTROL (DMA_0_BASE, 
                          ALTERA_AVALON_DMA_CONTROL_HW_MSK      | 
                          ALTERA_AVALON_DMA_CONTROL_GO_MSK        |
                          ALTERA_AVALON_DMA_CONTROL_I_EN_MSK      |
                          ALTERA_AVALON_DMA_CONTROL_WCON_MSK      |
                   //       ALTERA_AVALON_DMA_CONTROL_WEEN_MSK      |
                          ALTERA_AVALON_DMA_CONTROL_LEEN_MSK
              );
  }
}


