
#ifndef __LCD_TRI_1602_H__
#define __LCD_TRI_1602_H__

#include <stddef.h>

#include "sys/alt_dev.h"
#include "sys/alt_alarm.h"
#include "os/alt_sem.h"

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

typedef struct
{
  alt_dev        dev;
  int            base;
} LCD_TRI_1602_dev ;

//extern int LCD1602_writestring(unsigned int base, unsigned char* ptr, unsigned char line);

extern int LCD1602_write(alt_fd* fd, const char* ptr, int len);
extern void LCD1602_Init(LCD_TRI_1602_dev *dev);

#if (!defined(ALT_USE_SMALL_DRIVERS) && !defined(ALT_SIM_OPTIMIZE))// || defined ALT_USE_LCD_16207


#define LCD_TRI_1602_INSTANCE(name, device)   \
  static LCD_TRI_1602_dev device =                      \
    {                                                    \
      {                                                  \
        ALT_LLIST_ENTRY,                                 \
        name##_NAME,                                     \
        NULL, /* open */                                 \
        NULL, /* close */                                \
        NULL, /* read */                                 \
        LCD1602_write,                                   \
        NULL, /* lseek */                                \
        NULL, /* fstat */                                \
        NULL, /* ioctl */                                \
      },                                                 \
      name##_BASE                                        \
    }


#define LCD_TRI_1602_INIT(name, device) LCD1602_Init(&device);

#else /* exclude driver */

#define LCD_TRI_1602_INSTANCE(name, dev) extern int alt_no_storage
#define LCD_TRI_1602_INIT(name, dev) while (0)

#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif

