module seg7led(clk,reset_n,chipselect,address,write_n,writedata,read_n,readdata,seg_data,seg_com);
input clk;
input reset_n;
input chipselect;
input write_n;
input read_n;
input [1:0]address;
input [7:0]writedata;
output [7:0]readdata;
output [7:0]seg_data;
output [3:0]seg_com;

reg [7:0]outdata;
reg [7:0]datain[3:0];
reg [3:0]seg_com;
reg [7:0]seg_data;
reg [7:0]bcd_led;
reg [36:0]count;
//wire [1:0]comclk;

assign readdata=outdata;
always @(posedge clk)
begin
	if(!reset_n)
	begin
		datain[0]<=8'h00000000;
		datain[1]<=8'h00000000;
		datain[2]<=8'h00000000;
		datain[3]<=8'h00000000;
	end
	else if(!read_n)
			outdata<=datain[address];
		else if(!write_n)
			datain[address]<=writedata;
end

always @(posedge clk)
begin
	count=count+1;
end

always @(count[14:13])
begin
	case(count[14:13])
		2'b00:
		    begin
		     bcd_led = datain[0];
		     seg_com  = 4'b0001;
		    end
		2'b01:
		    begin
		     bcd_led=datain[1];
		     seg_com=4'b0010;
		    end
		2'b10:
		    begin
		     bcd_led=datain[2];
		     seg_com=4'b0100;
		    end
		2'b11:
		    begin
		     bcd_led=datain[3];
		     seg_com=4'b1000;
		    end
	endcase

end

always @(seg_com)
begin
	case(bcd_led[3:0])
		4'h0:seg_data=8'hc0;
		4'h1:seg_data=8'hf9;
		4'h2:seg_data=8'ha4;
		4'h3:seg_data=8'hb0;
		4'h4:seg_data=8'h99;
		4'h5:seg_data=8'h92;
		4'h6:seg_data=8'h82;
		4'h7:seg_data=8'hf8;
		4'h8:seg_data=8'h80;
		4'h9:seg_data=8'h90;
		4'ha:seg_data=8'h88;
		4'hb:seg_data=8'h83;
		4'hc:seg_data=8'hc6;
		4'hd:seg_data=8'ha1;
		4'he:seg_data=8'h86;
		4'hf:seg_data=8'h8e;
	endcase
end

endmodule

