#include "system.h"
#include <alt_types.h>
#include "altera_avalon_pio_regs.h"

#include "oc_i2c_regs.h"
#include "unistd.h"

extern void I2CWaitTIP(alt_u32 base);
extern void InitI2C();

void I2CWritedata(alt_u32 base, alt_u8 address, alt_u8 reg, alt_u8 data)//, alt_u16 num)
{
 // alt_u16 i;
  // Wait for the completion of transfer
  usleep(1000);
  I2CWaitTIP(base);
  // write address of I2C slave device
  // and generate START & WR command
  IOWR_OC_I2C_TXR(base, address);
  IOWR_OC_I2C_CR(base, I2C_CR_STA | I2C_CR_WR);
  I2CWaitTIP(base);
  // write register address
  IOWR_OC_I2C_TXR(base, reg);
  IOWR_OC_I2C_CR(base, I2C_CR_WR);
  I2CWaitTIP(base);

  /* write data
  if(num > 0) 
  {
    tmp = num - 1;
    for(i=0; i<tmp; i++)
    {
       IOWR_OC_I2C_TXR(base,*buf++);
       IOWR_OC_I2C_CR(base, I2C_CR_WR);
       I2CWaitTIP(base);
    }
  }
*/
  // write data with STOP signal
  IOWR_OC_I2C_TXR(base, data);
  IOWR_OC_I2C_CR(base, I2C_CR_WR | I2C_CR_STO);
  I2CWaitTIP(base);
}


unsigned char I2CReaddata(alt_u32 base, alt_u8 address, alt_u8 reg)//, alt_u16 num)
{
 // alt_u16 i;
  alt_u8 data;
  // Wait for the completion of transfer
  I2CWaitTIP(base);
 
  // write address of I2C slave device
  // and generate START & WR command
  IOWR_OC_I2C_TXR(base, address);
  IOWR_OC_I2C_CR(base, I2C_CR_STA | I2C_CR_WR);
  I2CWaitTIP(base);

  // write register address
  IOWR_OC_I2C_TXR(base, reg);
  IOWR_OC_I2C_CR(base, I2C_CR_WR);
  I2CWaitTIP(base);

  // write address of I2C slave device
  // and RD command
  IOWR_OC_I2C_TXR(base, address|1);
  IOWR_OC_I2C_CR(base, I2C_CR_STA | I2C_CR_WR);
  I2CWaitTIP(base);
  /* Read data
  if(num > 0) 
  {
    tmp = num - 1;
    for(i=0; i<tmp; i++)
    {
       IOWR_OC_I2C_CR(base,I2C_CR_RD | I2C_CR_ACK); 
       I2CWaitTIP(base);
       *buf++ = IORD_OC_I2C_RXR(base);
    }
  }
*/
  // Read data with STOP signal
  IOWR_OC_I2C_CR(base,I2C_CR_RD | I2C_CR_ACK | I2C_CR_STO); 
  I2CWaitTIP(base);
  data= IORD_OC_I2C_RXR(base);
  return data;
}


int main(void)
{ 
   alt_u16 i;
   alt_u8 data;
   unsigned char string[10]={0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9};
   unsigned char rxtbuff[10];
   InitI2C(OC_I2C_MASTER_0_BASE, 100000, 0);
   while(1)
   {

  //I2CRead(OC_I2C_MASTER_0_BASE, 0xa0, 0x0, rxtbuff[10], 10);
  for(i=0;i<10;i++)
  {
  I2CWritedata(OC_I2C_MASTER_0_BASE, 0xa2, i, string[i]);
  //delay();
  I2CWaitTIP(OC_I2C_MASTER_0_BASE);
  }
  for(i=0;i<20000;i++);
  
  for(i=0;i<10;i++)
  {
   data=I2CReaddata(OC_I2C_MASTER_0_BASE, 0xa2,i);
   rxtbuff[i]=data;
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_LED_BASE,data);
   I2CWaitTIP(OC_I2C_MASTER_0_BASE);
   usleep(100000);
  }
   i=0;
 }
 return 0;
 }
