#include  "system.h"
#include  "altera_avalon_pio_regs.h"
#include  "includes.h"

#define KEY  0xF

typedef enum keystate 
       {IDLE,AVOID_GLITCH,DOWN}
       KEYSTATE;

void KeyInit(void)
{
	INT32U tmp;
	tmp = IORD_ALTERA_AVALON_PIO_DIRECTION(PIO_KEY_BASE);
	IOWR_ALTERA_AVALON_PIO_DIRECTION(PIO_KEY_BASE, tmp);
}       

INT8U KeyState(void)
{
	if(IORD_ALTERA_AVALON_PIO_DATA(PIO_KEY_BASE) == KEY)
	    return 0;
	else
	    return 1;
}

INT8U KeyPoll(void)
{
	 static KEYSTATE state = IDLE;

	 switch(state)
	 {
	 	  case IDLE:
	 	  {
	 	  	if(KeyState() == 1)
	 	  	{
	 	  		   state = AVOID_GLITCH;
	 	  		   OSTimeDly(1);
	 	  	}
	 	  	else
	 	  	     state = IDLE;
	 	  	     
	 	  	break;
	 	  }     
	 	  case AVOID_GLITCH:
	 	  {
	 	  	if(KeyState() == 1)
	 	  	{
	 	  		   state = DOWN;
	 	  		   return 1;
	 	  	}
	 	   else
	 	    	state = IDLE;
	 	    	
	 	  break;
	 	  }
	 	  
	 	 case DOWN:
	 	  {
	 	  	if(KeyState() == 0)
	 	  	{
	 	  		state = IDLE;
	 	  	}
	 	   else
	 	    	state = DOWN;    		 	    	
	 	    break;
	 	  }
	 	  
	 	default:
	 		  state = IDLE;
	 }
	 
	 return 0;
}
