#include <stdlib.h> 
#include <stdio.h>  
#include "includes.h" 
#include "altera_avalon_pio_regs.h"
#include "simple_socket_server.h"                                                                    
#include "alt_error_handler.h"
#include "LCD.H"

INT32U key_down_num = 0;
extern int KeyPoll();
void InputTask()
{
    OS_CPU_SR  cpu_sr;
  while (1)
  {
    if(KeyPoll()==1)
    {
        OS_ENTER_CRITICAL();
        key_down_num++;
        OS_EXIT_CRITICAL();
        OSSemPost(key_down_sem);
    }
    else
      OSTimeDlyHMSM(0, 0, 0, 50);
  }
}

void OutputTask()
{
    INT8U error_code = OS_NO_ERR;
    INT8U key_temp;
  while (1)
  {
    OSSemPend(key_down_sem, 0, &error_code);
    alt_uCOSIIErrorHandler(error_code, 0);
   // printf("\n");
  //  printf("Output Task got the semaphore\n");
   // printf("Key down %ld times.\n",key_down_num);
   key_temp=(IORD_ALTERA_AVALON_PIO_DATA(PIO_KEY_BASE)&0xf);
   Lcd12864Clear(LCD_TRI_12864_0_BASE);
   switch(key_temp)
   {
    case 0x7:Disstring_line(LCD_TRI_12864_0_BASE,"KEY1 pressed",12,0);break;
    case 0xb:Disstring_line(LCD_TRI_12864_0_BASE,"KEY2 pressed",12,1);break;
    case 0xd:Disstring_line(LCD_TRI_12864_0_BASE,"KEY3 pressed",12,2);break;
    case 0xe:Disstring_line(LCD_TRI_12864_0_BASE,"KEY4 pressed",12,3);
 //  Disstring_line(LCD_TRI_12864_0_BASE,"KEY press ",24,6,1);
   }
  }
  
}
/****************************************************/