
 
#include <stdio.h>
#include "includes.h"
#include "simple_socket_server.h"                                                                    
#include "alt_error_handler.h"

#include "alt_lwip_dev.h"
#include "lwip/sys.h"
#include "lwip/netif.h"
#include "lwip/sockets.h"
#include "LCD.H"
#include "ziku.h"
#include "IO.H"
//#include "PCF8563.h"


extern void beep_test();
/*
 * init_done_func()
 * 
 * This function is called once the lwIP stack is alive, as specified in our
 * lwip_stack_init() call in main(), below.
 *
 * We tell it about each of our network devices and start the application & 
 * timer threads as appropriate.
 */
 
static void init_done_func(void *arg)
{
  /* 
   * At this point lwIP has been initialized, but the Ethernet interface has
   * not; the lwip_devices_init() call does so, adding in MicroC-OS/II
   * threads for low-level Ethernet MAC interface and TCP protocol timer.
   */
   if (!lwip_devices_init(LWIP_RX_ETHER_TASK_PRIORITY))
   {
      alt_lwIPErrorHandler(EXPANDED_DIAGNOSIS_CODE,
"[init_done_func] Fatal: lwip_devices_init failed, perhaps ethernet interface.");
   } 

#if LWIP_DHCP == 1
  /* 
   * If DHCP is enabled, activate a thread for the 120-second long time period
   * that will set a static IP address if acquisistion via DHCP times out. 
   */
   if (!sys_thread_new(NETUTILSDHCPTimeoutTask, NULL, 
                       NETUTILS_DHCP_TIMEOUT_TASK_PRIORITY))
   {
      alt_lwIPErrorHandler(EXPANDED_DIAGNOSIS_CODE,
                 "[init_done_func] Fatal: Can't add NETUTILSDHCPTimeoutTask!");
   }
#endif /* LWIP_DHCP */
  
  /* 
   * Add any application task(s) that rely on lwIP:
   *  
   * 1. SSSSimpleSocketServerTask() - Creates listening sockets, manages 
   *          incoming connection requests, and handles all simple socket 
   *          server communication.
   */
   if(!sys_thread_new(SSSSimpleSocketServerTask, NULL, 
                      SSS_SIMPLE_SOCKET_SERVER_TASK_PRIORITY))
   {
      alt_lwIPErrorHandler(EXPANDED_DIAGNOSIS_CODE,
              "[init_done_func] Fatal: Can't add SSSSimpleSocketServerTask!");  
   }
}

char RowAddrP,PageAddrP;
alt_u8 clean_lcd=1;
void PS2_interrupts()//PS2жϷ
{
  // alt_irq_disable(PS2_0_IRQ);//رPS2ж
   alt_irq_context context=alt_irq_disable_all();
    alt_u16 kbdata;
  //  char RowAddrP,PageAddrP;
    if(clean_lcd)
     Lcd12864Clear(LCD_TRI_12864_0_BASE);
     clean_lcd=0;
     kbdata= IORD(PS2_0_BASE,0);
     usleep(20);

  //   printf("0x%2X \n",kbdata);
     if(++RowAddrP>=0)
      {
      if(RowAddrP<12 )/*ûг64(5*12)ʾһַռ5*/  
         DisChar(LCD_TRI_12864_0_BASE,PageAddrP,RowAddrP*5,(char)kbdata,1);
         else if(RowAddrP<24)   
           DisChar(LCD_TRI_12864_0_BASE,PageAddrP,(RowAddrP-12)*5,(char)kbdata,2);
           else /*ʾﵽҰߣʾһҳһ*/
            {
             DisChar(LCD_TRI_12864_0_BASE,PageAddrP+1,0,(char)kbdata,1);
             RowAddrP = -1;
             if(++PageAddrP>=8)            
               PageAddrP=0;
            }
      }
       // alt_irq_enable(PS2_0_IRQ);//꿪ж
       alt_irq_enable_all(context);
}

/* Main initializes lwIP, creates a single task and starts task scheduler.
 */
 
int main (int argc, char* argv[], char* envp[])
{
  
  INT8U error_code;
   beep_test();
   Lcd12864Init(LCD_TRI_12864_0_BASE);//LCD12864ʼ
   Lcd12864Init(LCD_TRI_12864_0_BASE);//LCD12864ʼ
   Lcd12864Clear(LCD_TRI_12864_0_BASE);
   Lcd12864Clear(LCD_TRI_12864_0_BASE);
   Dishaizi(LCD_TRI_12864_0_BASE,0,32,0,1,ziku1);//
   Dishaizi(LCD_TRI_12864_0_BASE,0,48,1,1,ziku1);//ӭ
   Dishaizi(LCD_TRI_12864_0_BASE,0,0 ,2,2,ziku1);//
   Dishaizi(LCD_TRI_12864_0_BASE,0,16,3,2,ziku1);//
      
   Dishaizi(LCD_TRI_12864_0_BASE,3,0 ,0,1,ziku2);//Ƕ
   Dishaizi(LCD_TRI_12864_0_BASE,3,16,1,1,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,32,2,1,ziku2);//ʽ
   Dishaizi(LCD_TRI_12864_0_BASE,3,48,3,1,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,0 ,4,2,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,16,5,2,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,32,6,2,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,48,7,2,ziku2);//
  
   Disstring_line(LCD_TRI_12864_0_BASE,"http://www.21control.com",24,6);
    alt_irq_register( PS2_0_IRQ, NULL, (void*)PS2_interrupts );
  
   InitI2C(OC_I2C_MASTER_0_BASE, 100000, 0);//I2CʼI2CٶΪ100K
   PCF8563_SET();//ʱоƬʼ
   
  /* 
   * Our very first call in an lwIP example design is to start up lwIP TCP/IP
   * stack. We specify a MicroC/OS-II thread priority for the tcp_ip thread,
   * as well as a call-back routine, init_done_func(), which is called once
   * the stack is alive and well.
   */
  lwip_stack_init(LWIP_TCPIP_TASK_PRIORITY, init_done_func, 0);
  
  error_code = OSTaskCreateExt(SSSInitialTask,
                             NULL,
                             (void *)&SSSInitialTaskStk[TASK_STACKSIZE],
                             SSS_INITIAL_TASK_PRIORITY,
                             SSS_INITIAL_TASK_PRIORITY,
                             SSSInitialTaskStk,
                             TASK_STACKSIZE,
                             NULL,
                             0);
  alt_uCOSIIErrorHandler(error_code, 0);

  printf("\nSimple Socket Server starting up\n");

    
  /*
   * As with all MicroC/OS-II designs, once the initial thread(s) and 
   * associated RTOS resources are declared, we start the RTOS. That's it!
   */
  OSStart();
  
  while(1); /* Correct Program Flow never gets here. */

  return -1;
}

